#include "cin.h"
#include <dlfcn.h>

#define METHOD_NAME "method.wm2"
#define CIN_FILE    "wm2.cin"

int imeRegister(iomeSysInfo *INFO,iomeRegistry *REG)
{
  char *Accept_System[]={
    "x",
    "tty",
    NULL
  };
  char **IME = Accept_System;
  int n = 0;

  while (n>=0&&IME[n]) {
    if (strcasecmp(INFO->system,IME[n])==0) n=-2;
    n++;
  }
  if (n>=0) return 0;
  REG->encoding      = "big5";
  REG->class         = "ime";
  REG->accept_system = Accept_System;
  return 1;
}

int imeInit(iomeConfig *CONF,iomeRecord *RECORD)
{
  void * HANDLE;
  xcinInit INIT;
  HANDLE = dlopen("cin.so",RTLD_LAZY);
  INIT   = dlsym(HANDLE,"imeInit");
  return INIT(CONF,RECORD,METHOD_NAME,CIN_FILE);
}

int imePrepare(iomeRecord *RECORD)
{
  INMD *inmd = RECORD->Owner;
  return inmd->PREPARE(RECORD);
}

int imeFeedKey(iomeRecord *RECORD,int ch,int state)
{
  INMD *inmd = (INMD*)RECORD->Owner;
  return inmd->FEEDKEY(RECORD,ch,state);
}

int imeListArea(iomeRecord *RECORD,int x,int y)
{
  INMD *inmd = (INMD*)RECORD->Owner;
  return inmd->LISTAREA(RECORD,x,y);
}

int imeKeyArea(iomeRecord *RECORD,int x,int y)
{
  INMD *inmd = (INMD*)RECORD->Owner;
  return inmd->KEYAREA(RECORD,x,y);
}

int imeFocus(iomeRecord *RECORD)
{
  INMD *inmd = (INMD*)RECORD->Owner;
  return inmd->FOCUS(RECORD);
}

int imeQuit(iomeRecord *RECORD)
{
  INMD *inmd = RECORD->Owner;
  return inmd->QUIT(RECORD);
}
